# c function prototype is
# int poolmap (int* num_loci, int* pd, int* qd, int* pc, int* qc, double* log_lik_null, double* log_lik_mle, double* log_lik, int* x_mle);

dyn.load("poolmap.so")
poolmap <- function(pd,qd,pc,qc) {
  # should check lengths of vectors all equal
  .C("poolmap",
     n = as.integer(length(pd)),
     pd = as.integer(pd),
     qd = as.integer(qd),
     pc = as.integer(pc),
     qc = as.integer(qc),
     llnull = as.double(0),
     llmle = as.double(0),
     ll = double(length(pd)+1),
     xm = integer(length(pd)+1))
}

hosking <- read.table("Hosking_27SNP",header=TRUE)
attach(hosking)

profile <- poolmap(pd,qd,pc,qc)

plot(c(map[1]-.001,map,map[length(map)-1]+.001),(c(profile$ll[1],profile$ll)-profile$llnull)/log(10),type="s")

plot(c(map[1]-.001,map,map[length(map)-1]+.001),exp(c(profile$ll[1],profile$ll)-profile$llmle),type="s")

dyn.unload("plugin.so")

